#!/usr/bin/perl -w

package _DanovaKalkulacka;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::_NumericEntry;
use lib::Tools;


sub init {
    my $self=shift;
    my $class=ref($self);
    my $x=80;
    my $y=24;
    $self->{'vcdph3_bgcolor'}="#A0A0F0";
    
    $self->FORM->{'hbox_z0'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_z0'}, 1, 2, 2, 3, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_z0'}->set_size_request($x,$y);
    $self->FORM->{'hbox_z0'}->show;
    $self->FORM->{'fixed_z0'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_z0'}->pack_start($self->FORM->{'fixed_z0'}, 1, 1, 0);
    $self->FORM->{'fixed_z0'}->show;
    $self->FORM->{'z0'}=new _NumericEntry;
    $self->FORM->{'hbox_z0'}->pack_start($self->FORM->{'z0'}->get_widget, 0, 0, 0);
    $self->FORM->{'z0'}->set_size($x,$y);
    $self->FORM->{'z0'}->signal_connect("changed","$class\::z0_changed",$self);
    $self->FORM->{'z0'}->show;
    $self->FORM->{'label_z0'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_z0'}->set_use_underline('0');
    $self->FORM->{'label_z0'}->set_use_markup('1');
    $self->FORM->{'label_z0'}->set_selectable('0');
    $self->FORM->{'label_z0'}->set_justify('right');
    $self->FORM->{'label_z0'}->set_line_wrap('0');
    $self->FORM->{'label_z0'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_z0'}->set_padding(0, 0);
    $self->FORM->{'hbox_z0'}->pack_start($self->FORM->{'label_z0'},0,0,0);
    $self->FORM->{'label_z0'}->hide;
    $self->change_label('z0');


    $self->FORM->{'hbox_z1'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_z1'}, 1, 2, 3, 4, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_z1'}->set_size_request($x,$y);
    $self->FORM->{'hbox_z1'}->show;
    $self->FORM->{'fixed_z1'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_z1'}->pack_start($self->FORM->{'fixed_z1'}, 1, 1, 0);
    $self->FORM->{'fixed_z1'}->show;
    $self->FORM->{'z1'}=new _NumericEntry;
    $self->FORM->{'hbox_z1'}->pack_start($self->FORM->{'z1'}->get_widget, 0, 0, 0);
    $self->FORM->{'z1'}->set_size($x,$y);
    $self->FORM->{'z1'}->signal_connect("changed","$class\::z1_changed",$self);
    $self->FORM->{'z1'}->show;
    $self->FORM->{'label_z1'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_z1'}->set_use_underline('0');
    $self->FORM->{'label_z1'}->set_use_markup('1');
    $self->FORM->{'label_z1'}->set_selectable('0');
    $self->FORM->{'label_z1'}->set_justify('right');
    $self->FORM->{'label_z1'}->set_line_wrap('0');
    $self->FORM->{'label_z1'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_z1'}->set_padding(0, 0);
    $self->FORM->{'hbox_z1'}->pack_start($self->FORM->{'label_z1'},0,0,0);
    $self->FORM->{'label_z1'}->hide;
    $self->change_label('z1');


    $self->FORM->{'hbox_z2'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_z2'}, 1, 2, 4, 5, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_z2'}->set_size_request($x,$y);
    $self->FORM->{'hbox_z2'}->show;
    $self->FORM->{'fixed_z2'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_z2'}->pack_start($self->FORM->{'fixed_z2'}, 1, 1, 0);
    $self->FORM->{'fixed_z2'}->show;
    $self->FORM->{'z2'}=new _NumericEntry;
    $self->FORM->{'hbox_z2'}->pack_start($self->FORM->{'z2'}->get_widget, 0, 0, 0);
    $self->FORM->{'z2'}->set_size($x,$y);
    $self->FORM->{'z2'}->signal_connect("changed","$class\::z2_changed",$self);
    $self->FORM->{'z2'}->show;
    $self->FORM->{'label_z2'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_z2'}->set_use_underline('0');
    $self->FORM->{'label_z2'}->set_use_markup('1');
    $self->FORM->{'label_z2'}->set_selectable('0');
    $self->FORM->{'label_z2'}->set_justify('right');
    $self->FORM->{'label_z2'}->set_line_wrap('0');
    $self->FORM->{'label_z2'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_z2'}->set_padding(0, 0);
    $self->FORM->{'hbox_z2'}->pack_start($self->FORM->{'label_z2'},0,0,0);
    $self->FORM->{'label_z2'}->hide;
    $self->change_label('z2');
    

    $self->FORM->{'hbox_z3'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_z3'}, 1, 2, 6, 7, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_z3'}->set_size_request($x,$y);
    $self->FORM->{'hbox_z3'}->show;
    $self->FORM->{'fixed_z3'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_z3'}->pack_start($self->FORM->{'fixed_z3'}, 1, 1, 0);
    $self->FORM->{'fixed_z3'}->show;
    $self->FORM->{'z3'}=new _NumericEntry;
    $self->FORM->{'hbox_z3'}->pack_start($self->FORM->{'z3'}->get_widget, 0, 0, 0);
    $self->FORM->{'z3'}->set_size($x,$y);
    $self->FORM->{'z3'}->signal_connect("changed","$class\::z3_changed",$self);
    $self->FORM->{'z3'}->show;
    $self->FORM->{'label_z3'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_z3'}->set_use_underline('0');
    $self->FORM->{'label_z3'}->set_use_markup('1');
    $self->FORM->{'label_z3'}->set_selectable('0');
    $self->FORM->{'label_z3'}->set_justify('right');
    $self->FORM->{'label_z3'}->set_line_wrap('0');
    $self->FORM->{'label_z3'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_z3'}->set_padding(0, 0);
    $self->FORM->{'hbox_z3'}->pack_start($self->FORM->{'label_z3'},0,0,0);
    $self->FORM->{'label_z3'}->hide;
    $self->change_label('z3');
    

    $self->FORM->{'hbox_dph1'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_dph1'}, 2, 3, 3, 4, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_dph1'}->set_size_request($x,$y);
    $self->FORM->{'hbox_dph1'}->show;
    $self->FORM->{'fixed_dph1'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_dph1'}->pack_start($self->FORM->{'fixed_dph1'}, 1, 1, 0);
    $self->FORM->{'fixed_dph1'}->show;
    $self->FORM->{'dph1'}=new _NumericEntry;
    $self->FORM->{'hbox_dph1'}->pack_start($self->FORM->{'dph1'}->get_widget, 0, 0, 0);
    $self->FORM->{'dph1'}->set_size($x,$y);
    $self->FORM->{'dph1'}->signal_connect("changed","$class\::dph1_changed",$self);
    $self->FORM->{'dph1'}->show;
    $self->FORM->{'label_dph1'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_dph1'}->set_use_underline('0');
    $self->FORM->{'label_dph1'}->set_use_markup('1');
    $self->FORM->{'label_dph1'}->set_selectable('0');
    $self->FORM->{'label_dph1'}->set_justify('right');
    $self->FORM->{'label_dph1'}->set_line_wrap('0');
    $self->FORM->{'label_dph1'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_dph1'}->set_padding(0, 0);
    $self->FORM->{'hbox_dph1'}->pack_start($self->FORM->{'label_dph1'},0,0,0);
    $self->FORM->{'label_dph1'}->hide;
    $self->change_label('dph1');


    $self->FORM->{'hbox_dph2'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_dph2'}, 2, 3, 4, 5, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_dph2'}->set_size_request($x,$y);
    $self->FORM->{'hbox_dph2'}->show;
    $self->FORM->{'fixed_dph2'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_dph2'}->pack_start($self->FORM->{'fixed_dph2'}, 1, 1, 0);
    $self->FORM->{'fixed_dph2'}->show;
    $self->FORM->{'dph2'}=new _NumericEntry;
    $self->FORM->{'hbox_dph2'}->pack_start($self->FORM->{'dph2'}->get_widget, 0, 0, 0);
    $self->FORM->{'dph2'}->set_size($x,$y);
    $self->FORM->{'dph2'}->signal_connect("changed","$class\::dph2_changed",$self);
    $self->FORM->{'dph2'}->show;
    $self->FORM->{'label_dph2'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_dph2'}->set_use_underline('0');
    $self->FORM->{'label_dph2'}->set_use_markup('1');
    $self->FORM->{'label_dph2'}->set_selectable('0');
    $self->FORM->{'label_dph2'}->set_justify('right');
    $self->FORM->{'label_dph2'}->set_line_wrap('0');
    $self->FORM->{'label_dph2'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_dph2'}->set_padding(0, 0);
    $self->FORM->{'hbox_dph2'}->pack_start($self->FORM->{'label_dph2'},0,0,0);
    $self->FORM->{'label_dph2'}->hide;
    $self->change_label('dph2');
    

    $self->FORM->{'hbox_dph3'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_dph3'}, 2, 3, 6, 7, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_dph3'}->set_size_request($x,$y);
    $self->FORM->{'hbox_dph3'}->show;
    $self->FORM->{'fixed_dph3'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_dph3'}->pack_start($self->FORM->{'fixed_dph3'}, 1, 1, 0);
    $self->FORM->{'fixed_dph3'}->show;
    $self->FORM->{'dph3'}=new _NumericEntry;
    $self->FORM->{'hbox_dph3'}->pack_start($self->FORM->{'dph3'}->get_widget, 0, 0, 0);
    $self->FORM->{'dph3'}->set_size($x,$y);
    $self->FORM->{'dph3'}->signal_connect("changed","$class\::dph3_changed",$self);
    $self->FORM->{'dph3'}->show;
    $self->FORM->{'label_dph3'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_dph3'}->set_use_underline('0');
    $self->FORM->{'label_dph3'}->set_use_markup('1');
    $self->FORM->{'label_dph3'}->set_selectable('0');
    $self->FORM->{'label_dph3'}->set_justify('right');
    $self->FORM->{'label_dph3'}->set_line_wrap('0');
    $self->FORM->{'label_dph3'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_dph3'}->set_padding(0, 0);
    $self->FORM->{'hbox_dph3'}->pack_start($self->FORM->{'label_dph3'},0,0,0);
    $self->FORM->{'label_dph3'}->hide;
    $self->change_label('dph3');


    $self->FORM->{'hbox_vcdph0'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_vcdph0'}, 3, 4, 2, 3, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_vcdph0'}->set_size_request($x,$y);
    $self->FORM->{'hbox_vcdph0'}->show;
    $self->FORM->{'fixed_vcdph0'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_vcdph0'}->pack_start($self->FORM->{'fixed_vcdph0'}, 1, 1, 0);
    $self->FORM->{'fixed_vcdph0'}->show;
    $self->FORM->{'vcdph0'}=new _NumericEntry;
    $self->FORM->{'hbox_vcdph0'}->pack_start($self->FORM->{'vcdph0'}->get_widget, 0, 0, 0);
    $self->FORM->{'vcdph0'}->set_size($x,$y);
    $self->FORM->{'vcdph0'}->signal_connect("changed","$class\::vcdph0_changed",$self);
    $self->FORM->{'vcdph0'}->show;
    $self->FORM->{'label_vcdph0'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_vcdph0'}->set_use_underline('0');
    $self->FORM->{'label_vcdph0'}->set_use_markup('1');
    $self->FORM->{'label_vcdph0'}->set_selectable('0');
    $self->FORM->{'label_vcdph0'}->set_justify('right');
    $self->FORM->{'label_vcdph0'}->set_line_wrap('0');
    $self->FORM->{'label_vcdph0'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_vcdph0'}->set_padding(0, 0);
    $self->FORM->{'hbox_vcdph0'}->pack_start($self->FORM->{'label_vcdph0'},0,0,0);
    $self->FORM->{'label_vcdph0'}->hide;
    $self->change_label('vcdph0');
    

    $self->FORM->{'hbox_vcdph1'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_vcdph1'}, 3, 4, 3, 4, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_vcdph1'}->set_size_request($x,$y);
    $self->FORM->{'hbox_vcdph1'}->show;
    $self->FORM->{'fixed_vcdph1'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_vcdph1'}->pack_start($self->FORM->{'fixed_vcdph1'}, 1, 1, 0);
    $self->FORM->{'fixed_vcdph1'}->show;
    $self->FORM->{'vcdph1'}=new _NumericEntry;
    $self->FORM->{'hbox_vcdph1'}->pack_start($self->FORM->{'vcdph1'}->get_widget, 0, 0, 0);
    $self->FORM->{'vcdph1'}->set_size($x,$y);
    $self->FORM->{'vcdph1'}->signal_connect("changed","$class\::vcdph1_changed",$self);
    $self->FORM->{'vcdph1'}->show;
    $self->FORM->{'label_vcdph1'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_vcdph1'}->set_use_underline('0');
    $self->FORM->{'label_vcdph1'}->set_use_markup('1');
    $self->FORM->{'label_vcdph1'}->set_selectable('0');
    $self->FORM->{'label_vcdph1'}->set_justify('right');
    $self->FORM->{'label_vcdph1'}->set_line_wrap('0');
    $self->FORM->{'label_vcdph1'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_vcdph1'}->set_padding(0, 0);
    $self->FORM->{'hbox_vcdph1'}->pack_start($self->FORM->{'label_vcdph1'},0,0,0);
    $self->FORM->{'label_vcdph1'}->hide;
    $self->change_label('vcdph1');

    
    $self->FORM->{'hbox_vcdph2'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_vcdph2'}, 3, 4, 4, 5, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_vcdph2'}->set_size_request($x,$y);
    $self->FORM->{'hbox_vcdph2'}->show;
    $self->FORM->{'fixed_vcdph2'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_vcdph2'}->pack_start($self->FORM->{'fixed_vcdph2'}, 1, 1, 0);
    $self->FORM->{'fixed_vcdph2'}->show;
    $self->FORM->{'vcdph2'}=new _NumericEntry;
    $self->FORM->{'hbox_vcdph2'}->pack_start($self->FORM->{'vcdph2'}->get_widget, 0, 0, 0);
    $self->FORM->{'vcdph2'}->set_size($x,$y);
    $self->FORM->{'vcdph2'}->signal_connect("changed","$class\::vcdph2_changed",$self);
    $self->FORM->{'vcdph2'}->show;
    $self->FORM->{'label_vcdph2'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_vcdph2'}->set_use_underline('0');
    $self->FORM->{'label_vcdph2'}->set_use_markup('1');
    $self->FORM->{'label_vcdph2'}->set_selectable('0');
    $self->FORM->{'label_vcdph2'}->set_justify('right');
    $self->FORM->{'label_vcdph2'}->set_line_wrap('0');
    $self->FORM->{'label_vcdph2'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_vcdph2'}->set_padding(0, 0);
    $self->FORM->{'hbox_vcdph2'}->pack_start($self->FORM->{'label_vcdph2'},0,0,0);
    $self->FORM->{'label_vcdph2'}->hide;
    $self->change_label('vcdph2');


    $self->FORM->{'hbox_vcdph3'}=new Gtk2::HBox(0, 0);
    $self->FORM->{'table_kalkulacka'}->attach($self->FORM->{'hbox_vcdph3'}, 3, 4, 6, 7, ['fill', 'expand'], ['fill', 'expand'], 0, 0);
    $self->FORM->{'hbox_vcdph3'}->set_size_request($x,$y);
    $self->FORM->{'hbox_vcdph3'}->show;
    $self->FORM->{'fixed_vcdph3'}= new Gtk2::Fixed;
    $self->FORM->{'hbox_vcdph3'}->pack_start($self->FORM->{'fixed_vcdph3'}, 1, 1, 0);
    $self->FORM->{'fixed_vcdph3'}->show;
    $self->FORM->{'vcdph3'}=new _NumericEntry;
    $self->FORM->{'hbox_vcdph3'}->pack_start($self->FORM->{'vcdph3'}->get_widget, 0, 0, 0);
    $self->FORM->{'vcdph3'}->set_size($x,$y);
    $self->FORM->{'vcdph3'}->signal_connect("changed","$class\::vcdph3_changed",$self);
    $self->FORM->{'vcdph3'}->show;
    $self->FORM->{'label_vcdph3'}=new Gtk2::Label(_('0'));
    $self->FORM->{'label_vcdph3'}->set_use_underline('0');
    $self->FORM->{'label_vcdph3'}->set_use_markup('1');
    $self->FORM->{'label_vcdph3'}->set_selectable('0');
    $self->FORM->{'label_vcdph3'}->set_justify('right');
    $self->FORM->{'label_vcdph3'}->set_line_wrap('0');
    $self->FORM->{'label_vcdph3'}->set_alignment(0.5, 0.5);
    $self->FORM->{'label_vcdph3'}->set_padding(0, 0);
    $self->FORM->{'hbox_vcdph3'}->pack_start($self->FORM->{'label_vcdph3'},0,0,0);
    $self->FORM->{'label_vcdph3'}->hide;
    $self->change_label('vcdph3');
    $self->FORM->{'vcdph3'}->modify_bg("normal",$self->{'vcdph3_bgcolor'});
    

    $self->{'zaokrouhleni_dph'}=0;
    $self->{'zaokrouhleni_dph_m'}=2;
    $self->{'zaokrouhleni_celkem'}=0;
    $self->{'zaokrouhleni_celkem_m'}=2;
    $self->{'zaokrouhleni_celkem_rozpoustet'}=0;
    $self->{'freeze'}=0;
    
    $self->set_sazbydph(0,0);
    $self->{'show_dph'}=1;
    $self->{'editable'}=1;
    $self->set_editable($self->{'editable'});
};

sub signal_connect {
    my $self=shift;
    my $signal=shift;
    
    @{$self->{'sig_'.$signal}}=@_;
};

sub set_editable {
    my($self,$value)=@_;
    
    $self->{'editable'}=$value;
    if($value eq "1") {
        $self->FORM->{'label_z0'}->hide;
        $self->FORM->{'label_z1'}->hide;
        $self->FORM->{'label_z2'}->hide;
        $self->FORM->{'label_z3'}->hide;
        $self->FORM->{'label_dph1'}->hide;
        $self->FORM->{'label_dph2'}->hide;
        $self->FORM->{'label_dph3'}->hide;
        $self->FORM->{'label_vcdph0'}->hide;
        $self->FORM->{'label_vcdph1'}->hide;
        $self->FORM->{'label_vcdph2'}->hide;
        $self->FORM->{'label_vcdph3'}->hide;
        if($self->{'show_dph'} eq 1) {
            $self->FORM->{'z0'}->show;
            $self->FORM->{'z1'}->show;
            $self->FORM->{'z2'}->show;
            $self->FORM->{'z3'}->show;
            $self->FORM->{'dph1'}->show;
            $self->FORM->{'dph2'}->show;
            $self->FORM->{'dph3'}->show;
            $self->FORM->{'vcdph0'}->show;
            $self->FORM->{'vcdph1'}->show;
            $self->FORM->{'vcdph2'}->show;
        } else {
            $self->FORM->{'z0'}->hide;
            $self->FORM->{'z1'}->hide;
            $self->FORM->{'z2'}->hide;
            $self->FORM->{'z3'}->hide;
            $self->FORM->{'dph1'}->hide;
            $self->FORM->{'dph2'}->hide;
            $self->FORM->{'dph3'}->hide;
            $self->FORM->{'vcdph0'}->hide;
            $self->FORM->{'vcdph1'}->hide;
            $self->FORM->{'vcdph2'}->hide;
            $self->FORM->{'label_zaklad'}->hide;
            $self->FORM->{'label_dph'}->hide;
            $self->FORM->{'label_vcdph'}->hide;
            $self->FORM->{'label_procento0'}->hide;
            $self->FORM->{'label_procento1'}->hide;
            $self->FORM->{'label_procento2'}->hide;
            $self->FORM->{'label_sazbadph0'}->hide;
            $self->FORM->{'label_sazbadph1'}->hide;
            $self->FORM->{'label_sazbadph2'}->hide;
        };
        $self->FORM->{'vcdph3'}->show;
    } else {
        $self->FORM->{'z0'}->hide;
        $self->FORM->{'z1'}->hide;
        $self->FORM->{'z2'}->hide;
        $self->FORM->{'z3'}->hide;
        $self->FORM->{'dph1'}->hide;
        $self->FORM->{'dph2'}->hide;
        $self->FORM->{'dph3'}->hide;
        $self->FORM->{'vcdph0'}->hide;
        $self->FORM->{'vcdph1'}->hide;
        $self->FORM->{'vcdph2'}->hide;
        $self->FORM->{'vcdph3'}->hide;
        if($self->{'show_dph'} eq 1) {
            $self->FORM->{'label_z0'}->show;
            $self->FORM->{'label_z1'}->show;
            $self->FORM->{'label_z2'}->show;
            $self->FORM->{'label_z3'}->show;
            $self->FORM->{'label_dph1'}->show;
            $self->FORM->{'label_dph2'}->show;
            $self->FORM->{'label_dph3'}->show;
            $self->FORM->{'label_vcdph0'}->show;
            $self->FORM->{'label_vcdph1'}->show;
            $self->FORM->{'label_vcdph2'}->show;
        } else {
            $self->FORM->{'label_z0'}->hide;
            $self->FORM->{'label_z1'}->hide;
            $self->FORM->{'label_z2'}->hide;
            $self->FORM->{'label_z3'}->hide;
            $self->FORM->{'label_dph1'}->hide;
            $self->FORM->{'label_dph2'}->hide;
            $self->FORM->{'label_dph3'}->hide;
            $self->FORM->{'label_vcdph0'}->hide;
            $self->FORM->{'label_vcdph1'}->hide;
            $self->FORM->{'label_vcdph2'}->hide;
            $self->FORM->{'label_zaklad'}->hide;
            $self->FORM->{'label_dph'}->hide;
            $self->FORM->{'label_vcdph'}->hide;
            $self->FORM->{'label_procento0'}->hide;
            $self->FORM->{'label_procento1'}->hide;
            $self->FORM->{'label_procento2'}->hide;
            $self->FORM->{'label_sazbadph0'}->hide;
            $self->FORM->{'label_sazbadph1'}->hide;
            $self->FORM->{'label_sazbadph2'}->hide;
        };
        $self->FORM->{'label_vcdph3'}->show;
    };
};

sub show_dph {
    my($self,$value)=@_;
    $self->{'show_dph'}=$value;
    $self->set_editable($self->{'editable'});
};

sub freeze {
    my($self)=@_;
    $self->{'in_changes'}=1;
};

sub unfreeze {
    my($self)=@_;
    $self->{'in_changes'}=0;
};

sub reparent {
    my ($self,$parent)=@_;
    $self->FORM->{'table_kalkulacka'}->reparent($parent);
};

sub set_zaokrouhleni_dph {
    my ($self,$zaokrouhleni,$zaokrouhleni_m)=@_;
    $self->{'zaokrouhleni_dph'}=$zaokrouhleni;
    $self->{'zaokrouhleni_dph_m'}=$zaokrouhleni_m;
};

sub set_zaokrouhleni_ceny_celkem {
    my ($self,$zaokrouhleni,$zaokrouhleni_m,$zaokrouhleni_rozpoustet)=@_;
    $self->{'zaokrouhleni_celkem'}=$zaokrouhleni;
    $self->{'zaokrouhleni_celkem_m'}=$zaokrouhleni_m;
    $self->{'zaokrouhleni_celkem_rozpoustet'}=$zaokrouhleni_rozpoustet;
};

sub show {
    my $self=shift;
    $self->FORM->{'table_kalkulacka'}->show;
};

sub hide {
    my $self=shift;
    $self->FORM->{'table_kalkulacka'}->hide;
};

sub set_sazbydph {
    my($self,$sazbadph1,$sazbadph2)=@_;
    $self->{'sazbadph1'}=$sazbadph1;
    $self->{'sazbadph2'}=$sazbadph2;
    $self->FORM->{'label_sazbadph1'}->set_label($sazbadph1*1);
    $self->FORM->{'label_sazbadph2'}->set_label($sazbadph2*1);
    $self->prepocitat;
};

sub zaokrouhleni_celkem {
    my $self=shift;
    my $celkem_z=Tools::zaokrouhleni($self->FORM->{'vcdph0'}->get_value+$self->FORM->{'vcdph1'}->get_value+$self->FORM->{'vcdph2'}->get_value,$self->{'zaokrouhleni_celkem'},$self->{'zaokrouhleni_celkem_m'});
    my $celkem=$self->FORM->{'vcdph0'}->get_value+$self->FORM->{'vcdph1'}->get_value+$self->FORM->{'vcdph2'}->get_value;
    my $rozdil=$celkem_z-$celkem;
    if($rozdil!=0) {
        if($self->{'zaokrouhleni_celkem_rozpoustet'} eq 0) {
            $self->FORM->{'vcdph3'}->set_value($celkem_z);
        } else {
            my $procento=$self->FORM->{'vcdph3'}->get_value/100;
            tie(my $val,"FloatingFixedScalar");
            my $val0=Tools::zaokrouhleni2(($rozdil/100)*($self->FORM->{'vcdph0'}->get_value/$procento),2,0.01);
            my $val1=Tools::zaokrouhleni2(($rozdil/100)*($self->FORM->{'vcdph1'}->get_value/$procento),2,0.01);
            my $val2=Tools::zaokrouhleni2(($rozdil/100)*($self->FORM->{'vcdph2'}->get_value/$procento),2,0.01);
            my $zbytek=$rozdil-$val0-$val1-$val2;
            if($val2) {
                $val2+=$zbytek;
                $zbytek=0;
            };
            $self->FORM->{'vcdph2'}->set_value($self->FORM->{'vcdph2'}->get_value+$val2);
            if($val1) {
                $val1+=$zbytek;
                $zbytek=0;
            };
            $self->FORM->{'vcdph1'}->set_value($self->FORM->{'vcdph1'}->get_value+$val1);
            if($val0) {
                $val0+=$zbytek;
                $zbytek=0;
            };
            $self->FORM->{'vcdph0'}->set_value($self->FORM->{'vcdph0'}->get_value+$val0);
        };
    };
};

sub table_sum {
    my $self=shift;
    $self->FORM->{'vcdph3'}->set_value($self->FORM->{'vcdph0'}->get_value+$self->FORM->{'vcdph1'}->get_value+$self->FORM->{'vcdph2'}->get_value);
    $self->FORM->{'dph3'}->set_value($self->FORM->{'dph1'}->get_value+$self->FORM->{'dph2'}->get_value);
    $self->FORM->{'z3'}->set_value($self->FORM->{'z0'}->get_value+$self->FORM->{'z1'}->get_value+$self->FORM->{'z2'}->get_value);
};

sub prepocitat {
    my $self=shift;
    my $class=ref($self);
    
    _DanovaKalkulacka::z0_changed($self->FORM->{'z0'},$self);
    _DanovaKalkulacka::z1_changed($self->FORM->{'z1'},$self);
    _DanovaKalkulacka::z2_changed($self->FORM->{'z2'},$self);
};

sub set_value {
    my($self,%values)=@_;
    
    foreach $_ (keys(%values)) {
        $self->FORM->{$_}->set_value($values{$_});
    };
};

sub get_value {
    my($self,$numentry)=@_;
    
    return($self->FORM->{$numentry}->get_value);
};

sub change_label {
    my($self,$label)=@_;
    if($label eq "vcdph3") {
        my $val=$self->FORM->{$label}->get_widget->get_text;
        if($val=~/^-/) {
            $val='<span foreground="red">'.$val.'</span>'
        };
        $self->FORM->{"label_".$label}->set_label(_('<span background="'.$self->{'vcdph3_bgcolor'}.'">'.$val.'</span>'));
    } else {
        my $val=$self->FORM->{$label}->get_widget->get_text;
        if($val=~/^-/) {
            $val='<span foreground="red">'.$val.'</span>'
        };
        $self->FORM->{"label_".$label}->set_label(_($val));
    };
};

sub z0_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {
        $self->{'in_changes'}=1;
        $self->FORM->{'vcdph0'}->set_value($self->FORM->{'z0'}->get_value);
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('z0');
};

sub z1_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        $self->{'in_changes'}=1;
        tie(my $val,"FloatingFixedScalar");
        $val=($self->FORM->{'z1'}->get_value/100)*$self->{'sazbadph1'};
        $self->FORM->{'dph1'}->set_value(Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        $val=(($self->FORM->{'z1'}->get_value/100)*$self->{'sazbadph1'});
        $self->FORM->{'vcdph1'}->set_value(Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'})+$self->FORM->{'z1'}->get_value);
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('z1');
};


sub z2_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        $self->{'in_changes'}=1;
        tie(my $val,"FloatingFixedScalar");
        $val=($self->FORM->{'z2'}->get_value/100)*$self->{'sazbadph2'};
        $self->FORM->{'dph2'}->set_value(Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        $val=(($self->FORM->{'z2'}->get_value/100)*$self->{'sazbadph2'});
        $self->FORM->{'vcdph2'}->set_value(Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'})+$self->FORM->{'z2'}->get_value);
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('z2');
};

sub z3_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        #$self->{'in_changes'}=1;
        $self->FORM->{'z0'}->set_value($self->FORM->{'z3'}->get_value-($self->FORM->{'z1'}->get_value+$self->FORM->{'z2'}->get_value));
        #$self->table_sum;
        #$self->{'in_changes'}=0;
    };
    $self->change_label('z3');
};

sub dph1_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        $self->{'in_changes'}=1;
        $self->FORM->{'dph1'}->set_value(Tools::zaokrouhleni($self->FORM->{'dph1'}->get_value,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        tie(my $val,"FloatingFixedScalar");
        $val=($self->FORM->{'dph1'}->get_value/$self->{'sazbadph1'})*100;
        $self->FORM->{'z1'}->set_value($val);
        $self->FORM->{'vcdph1'}->set_value($val+$self->FORM->{'dph1'}->get_value);
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('dph1');
};

sub dph2_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        $self->{'in_changes'}=1;
        $self->FORM->{'dph2'}->set_value(Tools::zaokrouhleni($self->FORM->{'dph2'}->get_value,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        tie(my $val,"FloatingFixedScalar");
        $val=($self->FORM->{'dph2'}->get_value/$self->{'sazbadph2'})*100;
        $self->FORM->{'z2'}->set_value($val);
        $self->FORM->{'vcdph2'}->set_value($val+$self->FORM->{'dph2'}->get_value);
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('dph2');
};

sub dph3_changed {
    my($numentry,$self)=@_;
    $self->change_label('dph3');
};

sub vcdph0_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        $self->{'in_changes'}=1;
        $self->FORM->{'z0'}->set_value($self->FORM->{'vcdph0'}->get_value);
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('vcdph0');
};

sub vcdph1_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        $self->{'in_changes'}=1;
        tie(my $val,"FloatingFixedScalar");
        $val=($self->FORM->{'vcdph1'}->get_value/($self->{'sazbadph1'}+100))*$self->{'sazbadph1'};
        $self->FORM->{'dph1'}->set_value(Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        $val=($self->FORM->{'vcdph1'}->get_value/($self->{'sazbadph1'}+100))*$self->{'sazbadph1'};
        $self->FORM->{'z1'}->set_value($self->FORM->{'vcdph1'}->get_value-Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('vcdph1');
};

sub vcdph2_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        $self->{'in_changes'}=1;
        tie(my $val,"FloatingFixedScalar");
        $val=($self->FORM->{'vcdph2'}->get_value/($self->{'sazbadph1'}+100))*$self->{'sazbadph1'};
        $self->FORM->{'dph2'}->set_value(Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        $val=($self->FORM->{'vcdph2'}->get_value/($self->{'sazbadph2'}+100))*$self->{'sazbadph2'};
        $self->FORM->{'z2'}->set_value($self->FORM->{'vcdph2'}->get_value-Tools::zaokrouhleni($val,$self->{'zaokrouhleni_dph'},$self->{'zaokrouhleni_dph_m'}));
        $self->table_sum;
        $self->{'in_changes'}=0;
    };
    $self->change_label('vcdph2');
};

sub vcdph3_changed {
    my($numentry,$self)=@_;
    if(($numentry->get_value ne "") && (!$self->{'in_changes'})) {  
        #$self->{'in_changes'}=1;
        $self->FORM->{'z0'}->set_value($self->FORM->{'vcdph3'}->get_value-($self->FORM->{'vcdph1'}->get_value+$self->FORM->{'vcdph2'}->get_value));
        #$self->table_sum;
        #$self->{'in_changes'}=0;
    };
    $self->change_label('vcdph3');
    if(@{$self->{'sig_vcdph3_changed'}}) {
        my @sigevent=@{$self->{'sig_vcdph3_changed'}};
        eval "$sigevent[0] \$self,\$sigevent[1];";
    };
};

1;
